#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color2  Yellow
#property indicator_color3  Yellow
extern string TimeFrame       = 0;
extern int    HalfLength      = 56;
extern int    Price           = PRICE_WEIGHTED;
extern double BandsDeviations = 2.5;
double tmBuffer[];
double upBuffer[];
double dnBuffer[];
double wuBuffer[];
double wdBuffer[];
string IndicatorFileName;
bool   calculatingTma = false;
bool   returningBars  = false;
int init()
{
   HalfLength = MathMax(HalfLength,1);
   IndicatorBuffers(7);
         SetIndexBuffer(0,tmBuffer);  SetIndexStyle(0,DRAW_NONE,CLR_NONE);
         SetIndexBuffer(1,upBuffer);  SetIndexStyle(1,DRAW_LINE); 
         SetIndexBuffer(2,dnBuffer);  SetIndexStyle(2,DRAW_LINE); 
         SetIndexBuffer(3,wuBuffer);  SetIndexStyle(3,DRAW_NONE,CLR_NONE);
         SetIndexBuffer(4,wdBuffer);  SetIndexStyle(4,DRAW_NONE,CLR_NONE);
         if (TimeFrame=="calculateTma")  { calculatingTma=true; return(0); }
         if (TimeFrame=="returnBars")    { returningBars=true;  return(0); } 
   IndicatorFileName = WindowExpertName();
   return(0);
}
int deinit() { return(0); }

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limitb;
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limitb=MathMin(Bars-1,Bars-counted_bars+HalfLength);
           if (returningBars)  { tmBuffer[0] = limitb; return(0); }
           if (calculatingTma) { calculateTma(limitb); return(0); }
   
 	for(i = 500; i >= 0; i--)
   {
      int      shift1 = iBarShift(NULL,TimeFrame,Time[i]);

         tmBuffer[i] = iCustom(NULL,TimeFrame,IndicatorFileName,"calculateTma",HalfLength,Price,BandsDeviations,0,shift1);
         upBuffer[i] = iCustom(NULL,TimeFrame,IndicatorFileName,"calculateTma",HalfLength,Price,BandsDeviations,1,shift1);
         dnBuffer[i] = iCustom(NULL,TimeFrame,IndicatorFileName,"calculateTma",HalfLength,Price,BandsDeviations,2,shift1);  

   }
   return(0);
}
void calculateTma(int limit)
{
   int i,j,k;
   double FullLength = 2.0*HalfLength+1.0;

   for (i=limit; i>=0; i--)
   {
      double sum  = (HalfLength+1)*iMA(NULL,TimeFrame,1,0,MODE_SMA,Price,i);
      double sumw = (HalfLength+1);
      for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
      {
         sum  += k*iMA(NULL,TimeFrame,1,0,MODE_SMA,Price,i+j);
         sumw += k;

         if (j<=i)
         {
            sum  += k*iMA(NULL,TimeFrame,1,0,MODE_SMA,Price,i-j);
            sumw += k;
         }
      }
      tmBuffer[i] = sum/sumw;        
         double diff = iMA(NULL,TimeFrame,1,0,MODE_SMA,Price,i)-tmBuffer[i];
         if (i> (Bars-HalfLength-1)) continue;
         if (i==(Bars-HalfLength-1))
         {
            upBuffer[i] = tmBuffer[i];
            dnBuffer[i] = tmBuffer[i];
            if (diff>=0)
               {
                  wuBuffer[i] = MathPow(diff,2);
                  wdBuffer[i] = 0;
               }
            else
               {               
                  wdBuffer[i] = MathPow(diff,2);
                  wuBuffer[i] = 0;
               }                  
            continue;
         }
  
         if(diff>=0)
            {
               wuBuffer[i] = (wuBuffer[i+1]*(FullLength-1)+MathPow(diff,2))/FullLength;
               wdBuffer[i] =  wdBuffer[i+1]*(FullLength-1)/FullLength;
            }
         else
            {
               wdBuffer[i] = (wdBuffer[i+1]*(FullLength-1)+MathPow(diff,2))/FullLength;
               wuBuffer[i] =  wuBuffer[i+1]*(FullLength-1)/FullLength;
            }
         upBuffer[i] = tmBuffer[i] + BandsDeviations*MathSqrt(wuBuffer[i]);
         dnBuffer[i] = tmBuffer[i] - BandsDeviations*MathSqrt(wdBuffer[i]);
   }
}
